#include <iostream>

#ifndef WIN32
#include <sysexits.h>
#else
#define EX_USAGE 1
#define EX_CONFIG 2
#define EX_OK 0
#endif

#include <dblib/os_dep_process.h>

#include "client_main.h"
#include "client.h"

/*******************************************************************\

Function: client_maint::client_maint

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

client_maint::client_maint(const char *_service)
 {
  optstring="?hc:";
  service=service;
 }

/*******************************************************************\

Function: client_maint::client_maint

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

client_maint::client_maint(const char *_service,
                           const char *_optstring)
 {
  service=_service;
  optstring="?hc:";
  optstring+=_optstring;
 }

/*******************************************************************\

Function: client_maint::help

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void client_maint::help()
 {
 }

/*******************************************************************\

Function: client_maint::usage_error

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void client_maint::usage_error()
 {
  std::cerr << "Usage error!\n\n";
  help();
 }

/*******************************************************************\

Function: client_maint::config_defaults

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void client_maint::config_defaults()
 {
  if(client.config["hostname"]=="")
   {
    char hostname[100]="";
    gethostname(hostname, 100);
    client.config.set("hostname", hostname);
   }
 }

/*******************************************************************\

Function: client_maint::client_main

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

int client_maint::client_main(int argc, char **argv)
 {
  if(cmdline.parse(argc, argv, optstring.c_str()))
   {
    usage_error();
    return EX_USAGE;
   }

  std::string config_file;

   {
    const char *val=cmdline.getval('c');
    if(val!=NULL) config_file=val;
   }

  if(cmdline.isset('?') || cmdline.isset('h'))
   {
    help();
    return EX_OK;
   }

  if(config_file!="")
   {
    if(client.config.open(config_file))
     {
      std::cerr << "failed to read configuration from " 
                << config_file << "\n";
      return EX_CONFIG;
     }
   }

  config_defaults();

  client.init(service);
  
  return doit();
 }
