/*******************************************************************\

Module:

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#ifndef DBOX_DBCLIENT_LOCK_H
#define DBOX_DBCLIENT_LOCK_H

#include <string>

void lock(const std::string &type, const std::string &name, const std::string &module);
void unlock(const std::string &type, const std::string &name);

class lockt
 {
 public:
  lockt():locked(false) { }

  lockt(const std::string &type,
        const std::string &name,
        const std::string &module):locked(false)
   {
    lock(type, name, module);
   }
  
  virtual ~lockt()
   {
    if(locked) unlock();
   }
   
  virtual void lock(const std::string &type,
                    const std::string &name,
                    const std::string &module);

  virtual void unlock();
  
 protected:
  bool locked;
  std::string _type, _name;
 };

#endif
