#include <iostream>

#include <libdbox/stringtools.h>
#include <dblib/os_dep_process.h>
#include <dbclient/auth.h>
#include <dbclient/logstr.h>

#include "dbftpd.h"

/*******************************************************************\

Function:

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

bool dbftpdt::douser(const std::string &args)
 {
  if(login)
    out << "530 Already logged in.\r\n";
  else
   {
    username=args;
    dnstring(username); 
    out << "331 Password required.\r\n";
   }

  return FALSE;
 }

/*******************************************************************\

Function:

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

bool dbftpdt::dopass(const std::string &args)
 {
  if(login)
    out << "530 Already logged in.\r\n";
  else if(username=="")
    out << "503 Please login first.\r\n";
  else if(username=="ftp" || 
          username=="anonymous")
    out << "503 No anonymous access allowed.\r\n";
  else
   {
    try
     {
      autht auth;
      auth.auth(username, args);

      user.read(username);
      alias=username;

      if(user["alias"]!="")
       {
        username=user["alias"];
        user.read(username);
       }
     }

    catch(auth_excpt &e)
     {
      logstr << "login of " << username << " failed";
      logstr.log("dboxftpd");

      sleep(1);

      out << "503 Login incorrect.\r\n";
      login=FALSE;
      failcount--;
      if(failcount==0)
       {
        out << "221 Goodbye.\r\n";
        return TRUE;
       }

      return FALSE;
     }

    catch(table_excpt &e)
     {
      logstr << username << ": fatal: user table not found";
      logstr.log("dboxftpd");

      out << "503 Service not available\r\n";
      out << "221 Goodbye.\r\n";
      return TRUE;
     }

    #if 0
      strmaxcpy(status.gruppe.name, status.userprofile|"gruppe", TEXTLEN-1);

      status.gruppe.read();

      if(!getinternalflag(&status.userprofile, &status.gruppe, LOGIN_WEB))
       {
        logstr << "Permission denied";
        logstr.log("dboxftpd");
        out << "211 You have no permission.\r\n";
        return TRUE;
       }
      else
       {
        logstr << "Login successful, alias " << alias;
        logstr.log("dboxftpd");

        out << "230 User " << username << " logged in.\r\n";
        login=TRUE;
        
        homedir=homepagedir+alias+DIRCHAR;
        has_homedir=(access((homedir+".").c_str(), 00)==0);
       }
     }
    #endif
   }

  return FALSE;
 }
