/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <iostream>
#include <fstream>

#include <tools.h>
#include <lock.h>
#include <stringtools.h>
#include <dblib/i2string.h>
#include <dblib/os_dep_file.h>

#include "mod-utf7.h"
#include "dbimap4d.h"

/*******************************************************************\

Function: dbimap4dt::dodelete

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void dbimap4dt::dodelete()
 {
  if(arguments.size()!=1)
   {
    error("give a mailbox name");
    return;
   }

  if(arguments[0].data[arguments[0].data.size()-1]=='/')
   {
    std::cout << tag << " OK ignored\r\n";
    command_ok=FALSE;
    return;
   }

  std::string mailbox_name=decode_mod_utf7(arguments[0].data);

  if(mailbox_name=="")
   {
    error("give a non-empty mailbox name");
    return;
   }
  
  if(stringcasecmp(mailbox_name, "INBOX")==0)
   {
    error("cannot delete INBOX");
    return;
   }

  std::string subfolder;

   {  
    lockt folders_lock("folders", user, "dbimap4dt::dodelete");

    get_folder_list();

    unsigned i;

    for(i=0; i<folders.size(); i++)
      if(mailbox_name==folders[i].name)
        break;

    if(i==folders.size())
     {
      error("no such mailbox");
      return;
     }

    subfolder=i2string(i);
    folders[i].name="";

     {
      std::string outfilename=build_path(get_user_path(), "folders");
      std::ofstream out(outfilename.c_str(), std::ios::out|std::ios::trunc);

      for(i=0; i<folders.size(); i++)
        out << folders[i].name << "\n";
     }
   }

  // rename directory

   {
    mailfoldert new_mailfolder(user, subfolder);

    new_mailfolder.lock("dbimap4dt::dodelete");

    std::string foldersdir=build_path(get_user_path(), "mfolders");
    renamedirectory(foldersdir.c_str(), subfolder.c_str()); 
   }

 }
