/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#if 0
#ifndef WIN32
#include <unistd.h>
#endif

#include <winport.h>
#endif

#include <tools.h>
#include <sfolderrfc.h>
#include <stringtools.h>

#include <dblib/os_dep_file.h>
#include <dblib/i2string.h>

#include "dbimap4d.h"

/*******************************************************************\

Function: move_data_in_file

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

static
bool move_data_in_file(int file, off_t source, off_t dest, dword size)
 {
  dword buffersize, bytestocopy, bytestocopy2;
  void *buffer;

  if(source==dest) return FALSE;

  buffersize=64000l;
  if((buffer=malloc(buffersize))==NULL) return TRUE;
  bytestocopy=size;

  if(source>dest)
   {
    while(bytestocopy!=0)
     {
      bytestocopy2=bytestocopy>buffersize?buffersize:bytestocopy;

      lseek(file, source, SEEK_SET);

      if(read(file, buffer, bytestocopy2)!=(ssize_t)bytestocopy2)
       {
        free(buffer);
        return TRUE;
       }

      lseek(file, dest, SEEK_SET);

      if(write(file, buffer, bytestocopy2)!=(ssize_t)bytestocopy2)
       {
        free(buffer);
        return TRUE;
       }

      source+=bytestocopy2;
      dest+=bytestocopy2;

      bytestocopy-=bytestocopy2;
     }
   }
  else // source<dest 
   {
   }

  free(buffer);
  return FALSE;
 }

/*******************************************************************\

Function: dbimap4dt::doexpunge

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void dbimap4dt::doexpunge()
 {
  folder_grantst grants;
  get_folder_grants(mailfolder, grants);
  if(!grants.del)
   {
    error("permission denied");
    return;
   }

  clear_cached();

  mailfolder.lock("dbimap4dt::doexpunge");

  std::string expunge_response;

  dword read_nr=1, write_nr=1;
  off_t header_off=0;

  while(true)
   {
    lseek(index, (read_nr-1)*sizeof fi, SEEK_SET);
    if(read(index, &fi, sizeof fi)!=sizeof fi) break;

    if(fi.check_version())
     {
      mailfolder.unlock();
      error("Sorry, folder data error");
      return;
     }

    if(fi.flags.deleted)
     {
      expunge_response+="* "+i2string(write_nr)+" EXPUNGE\r\n";

      if(fi.flags.bodyextern)
       {
        std::string datafilename=
          build_path(mailfolder.get_path(), fi.file);
        remove(datafilename.c_str());
       }
     }
    else
     {
      dword header_size=fi.headerlen;
      if(!fi.flags.bodyextern) header_size+=fi.len;

      if(read_nr!=write_nr)
       {
        move_data_in_file(header, fi.headeroffs, 
                          header_off, header_size);

        fi.headeroffs=header_off;
        lseek(index, (write_nr-1)*sizeof fi, SEEK_SET);
        write(index, &fi, sizeof fi);
       }

      header_off+=header_size;
      write_nr++;
     }

    read_nr++;
   }

  if(read_nr!=write_nr)
   {
    ftruncate(index, (write_nr-1)*sizeof fi);
    ftruncate(header, header_off);
   }

  mailfolder.unlock();

  // send response after everything is done

  out << expunge_response;
 }

