/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dblib/os_dep_file.h>
#include <dbsmtpd/folder_profile.h>
#include <stringtools.h>

#include "mod-utf7.h"
#include "dbimap4d.h"

/*******************************************************************\

Function: dbimap4t::doselect

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void dbimap4dt::doselect()
 {
  command_ok=FALSE;
  readonly=(stringcasecmp(command, "EXAMINE")==0);

  if(arguments.size()!=1)
   {
    error("give a mailbox name");
    return;
   }

  if(process_mailbox_name(arguments[0].data, mailfolder))
    return;

  folder_grantst grants;
  get_folder_grants(mailfolder, grants);
  if(!grants.read)
   {
    error("permission denied");
    return;
   }

  if(mailbox_selected)
   {
    mailbox_selected=false;
    close();
   }

  if(open_mail())
   {
    out << tag << " NO internal error while opening folder\r\n";
    return;
   }
 
  mailbox_selected=true;

  folder_profilet fp(mailfolder);

  uidvalidity=fp.get_int("imap.uidvalidity");
  if(uidvalidity==0) uidvalidity=1;

  out << "* FLAGS (\\Answered \\Flagged \\Deleted \\Seen \\Draft)\r\n"
      << "* OK [PERMANENTFLAGS (\\Answered \\Flagged \\Deleted \\Seen \\Draft)]\r\n"
      << "* OK [UIDVALIDITY " << uidvalidity << "]\r\n";

  #ifdef DBOX_STANDALONE
  if(mailbox=="INBOX")
    movemail();
  #endif

  showstatus();
     
  out << tag << " OK [" << (readonly?"READ-ONLY":"READ-WRITE")
      << "] SELECT completed\r\n";
 }
