/*

  DBOX Module
  Copyright (C) 1994-2003 Daniel Kroening <kroening@handshake.de>

  Purpose: IMAP4 STATUS command

*/

#include <stringtools.h>
#include <dblib/os_dep_file.h>
#include <dbsmtpd/folder_profile.h>

#include "dbimap4d.h"

/*******************************************************************\

Function: dbimap4dt::dostatus

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void dbimap4dt::dostatus()
 {
  if(arguments.size()<1)
   {
    std::cout << tag << " NO give a mailbox name\r\n";
    command_ok=FALSE;
    return; 
   }

  mailfoldert status_mailfolder;

  if(process_mailbox_name(arguments[0].data, status_mailfolder))
    return;

  folder_grantst grants;
  get_folder_grants(status_mailfolder, grants);

  if(!grants.read)
   {
    std::cout << tag << " NO permission denied\r\n";
    command_ok=FALSE;
    return;
   }

  std::string directory=status_mailfolder.get_path();
  std::string indexfilename=build_path(directory, "index");

  folder_profilet new_fp(status_mailfolder);

  int index=::open(indexfilename.c_str(), O_BINARY|O_RDONLY);
  dword messages_in_folder=0, recent=0, unseen=0;

  if(index>=0)
   {
    while(read(index, &fi, sizeof fi)==sizeof fi)
     {
      messages_in_folder++;
      if(!fi.flags.seen) unseen++;
     }

    ::close(index);
   }

  out << "* STATUS ";
  send_string(arguments[0].data);
  out << ' ';

  begin_list();

  for(unsigned argnr=1; argnr<arguments.size(); argnr++)
   {
    std::string what=up_string(arguments[argnr].data);

    if(what=="MESSAGES")
     {
      list_item(); std::cout << "MESSAGES";
      list_item(); std::cout << messages_in_folder;
     }
    else if(what=="RECENT")
     {
      list_item(); std::cout << "RECENT";
      list_item(); std::cout << recent;
     }
    else if(what=="UIDNEXT")
     {
      dword nextid=new_fp.get_int("nextid");
      if(nextid==0) nextid=1;
      list_item(); std::cout << "UIDNEXT";
      list_item(); std::cout << nextid;
     }
    else if(what=="UIDVALIDITY")
     {
      dword uidvalidity=new_fp.get_int("imap.uidvalidity");
      if(uidvalidity==0) uidvalidity=1;
      list_item(); std::cout << "UIDVALIDITY";
      list_item(); std::cout << uidvalidity;
     }
    else if(what=="UNSEEN")
     {
      list_item(); std::cout << "UNSEEN";
      list_item(); std::cout << unseen;
     }
   }

  end_list();

  out << "\r\n";
 }
