/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dblib/os_dep_file.h>
#include <stringtools.h>

#include "imap4store.h"

/*******************************************************************\

Function: store_set_commandt::start

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

bool store_set_commandt::start()
 {
  const char *what=dbimap4d.arguments[argnr++].data.c_str();

  if(stricmp(what, "FLAGS")==0)
    flags=true;
  else if(stricmp(what, "FLAGS.SILENT")==0)
    flags=silent=true;
  else if(stricmp(what, "+FLAGS")==0)
    flags=add=true;
  else if(stricmp(what, "+FLAGS.SILENT")==0)
    flags=add=silent=true;
  else if(stricmp(what, "-FLAGS")==0)
    flags=remove=true;
  else if(stricmp(what, "-FLAGS.SILENT")==0)
    flags=remove=silent=true;
  else
   {
    dbimap4d.out << dbimap4d.tag
                 << " NO Sorry, I do not know how to store this.\r\n";
    dbimap4d.command_ok=false;
    return true;
   }

  folder_grantst grants;
  dbimap4d.get_folder_grants(dbimap4d.mailfolder, grants);
  if(!grants.write && !grants.keepseen)
   {
    dbimap4d.out << dbimap4d.tag << " NO permission denied\r\n";
    dbimap4d.command_ok=false;
    return true;
   }

  for(unsigned arg=argnr; arg<dbimap4d.arguments.size(); arg++)
    if(!grants.write && 
       stringcasecmp(dbimap4d.arguments[arg].data, "\\Seen")!=0)
     {
      dbimap4d.out << dbimap4d.tag << " NO permission denied\r\n";
      dbimap4d.command_ok=false;
      return true;
     }

  if(!grants.write && !remove)
   {
    dbimap4d.out << dbimap4d.tag << " NO permission denied\r\n";
    dbimap4d.command_ok=false;
    return true;
   }

  dbimap4d.mailfolder.lock("store_set_commandt::start");

  return false;
 }

/*******************************************************************\

Function: store_set_commandt::msg

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

bool store_set_commandt::msg()
 {
  dbimap4d.get_folderindex(nr-1);

  if(!add && !remove)
   {
    dbimap4d.fi.flags.imapflags=0;
    dbimap4d.fi.flags.deleted=false;
    dbimap4d.fi.flags.seen=false;
   }
 
  for(unsigned arg=argnr; arg<dbimap4d.arguments.size(); arg++)
   {
    const char *item=dbimap4d.arguments[arg].data.c_str();

    if(stricmp(item, "\\Answered")==0)
      dbimap4d.fi.flags.imapflags^=
        (((dbimap4d.fi.flags.imapflags&DBOXIMAP4_FLAG_Answered)==0)==!remove
        ?DBOXIMAP4_FLAG_Answered:0);
    else if(stricmp(item, "\\Flagged")==0)
      dbimap4d.fi.flags.imapflags^=
        (((dbimap4d.fi.flags.imapflags&DBOXIMAP4_FLAG_Flagged)==0)==!remove
        ?DBOXIMAP4_FLAG_Flagged:0);
    else if(stricmp(item, "\\Deleted")==0)
      dbimap4d.fi.flags.deleted=!remove;
    else if(stricmp(item, "\\Seen")==0)
      dbimap4d.fi.flags.seen=!remove;
    else if(stricmp(item, "\\Draft")==0)
      dbimap4d.fi.flags.imapflags^=
        (((dbimap4d.fi.flags.imapflags&DBOXIMAP4_FLAG_Draft)==0)==!remove
        ?DBOXIMAP4_FLAG_Draft:0);
   } 

  lseek(dbimap4d.index, (nr-1)*sizeof dbimap4d.fi, SEEK_SET);
  write(dbimap4d.index, &dbimap4d.fi, sizeof dbimap4d.fi);

  #ifndef DBOX_STANDALONE
  if(dbimap4d.fi.flags.deleted) dbimap4d.docrunch(dbimap4d.user);
  // TODO: subfolder
  #endif

  if(!silent)
   {
    dbimap4d.out << "* " << nr << " FETCH ";
    dbimap4d.begin_list();
    fetch("FLAGS");
    if(uid) fetch("UID");   
    dbimap4d.end_list();
    dbimap4d.out << "\r\n";
   }

  return false;
 }

/*******************************************************************\

Function: store_set_commandt::end

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void store_set_commandt::end()
 {
  dbimap4d.mailfolder.unlock();
 }

