/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>

#include <vector>
#include <algorithm>

#include <dblib/str_getline.h>

#include "sort.h"

/*******************************************************************\

Function: do_sort

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void do_sort(std::istream &in, std::ostream &out)
 {
  #if 0

  std::string line;
  std::vector<std::string> file;

  while(true)
   {
    if(!str_getline(in, line)) break;
    file.push_back(line);
   }

  std::sort(file.begin(), file.end());

  for(std::vector<std::string>::const_iterator it=file.begin();
      it!=file.end(); it++)
    out << *it << std::endl;

  #else

  // unfortunately, the streams are slow

  #define MAX 10000
  char line[MAX];
  std::vector<std::string> file;

  while(true)
   {
    if(fgets(line, MAX-1, stdin)==NULL) break;
    char *ptr=strchr(line, '\n');
    if(ptr!=NULL) *ptr=0;
    file.push_back(line);
   }

  std::sort(file.begin(), file.end());

  for(std::vector<std::string>::const_iterator it=file.begin();
      it!=file.end(); it++)
    puts(it->c_str());

  #endif
 }
