/*******************************************************************\

Module:

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#include "os_dep_file.h"

/*******************************************************************\

Function: build_path

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

std::string build_path(const std::string &path, const std::string &filename)
 {
  if(path=="")
    return filename;

  if(path[path.size()-1]==DIRCHAR[0])
    return path+filename;

  return path+DIRCHAR+filename;
 }

/*******************************************************************\

Function: filelength

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

unsigned long int filelength(const std::string &filename)
 {
  struct stat buf;
  if(stat(filename.c_str(), &buf)!=0) return 0;
  return buf.st_size;
 }

/*******************************************************************\

Function: filelength

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

#ifndef WIN32  
unsigned long filelength(int handle)
 {
  unsigned long oldpos=lseek(handle, 0, SEEK_CUR); // Unix - lseek gibt die
  unsigned long length=lseek(handle, 0, SEEK_END); // resultierende Position zurck
  lseek(handle, oldpos, SEEK_SET);
  return length;
 }
#endif

