/*******************************************************************\

Module:

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#include "os_dep_file.h"
#include "stream_copy.h"
#include "trfalse.h"

/*******************************************************************\

Function: filecopy

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

bool filecopy(std::istream &in, std::ostream &out, unsigned long int size)
 {
  unsigned long int buffersize, bytestocopy, bytestocopy2;
  char *buffer;

  buffersize=64000;
  if((buffer=(char *)malloc(buffersize))==NULL) return TRUE;
  bytestocopy=size;

  while(bytestocopy!=0)
   {
    bytestocopy2=bytestocopy>buffersize?buffersize:bytestocopy;

    if(!in.read(buffer, bytestocopy2))
     {
      free(buffer);
      return TRUE;
     }

    if(!out.write(buffer, bytestocopy2))
     {
      free(buffer);
      return TRUE;
     }

    bytestocopy-=bytestocopy2;
   }
  free(buffer);
  return FALSE;
 }

/*******************************************************************\

Function: filecopy

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

bool filecopy(std::istream &in, std::ostream &out)
 {
  unsigned long int buffersize;
  long int bytesread;
  char *buffer;

  buffersize=64000l;
  if((buffer=(char *)malloc(buffersize))==NULL) return TRUE;

  while(TRUE)
   {
    in.read(buffer, buffersize);

    bytesread=in.gcount();

    if(bytesread==0)
     {
      free(buffer);
      return FALSE;
     }

    if(!out.write(buffer, bytesread))
     {
      free(buffer);
      return TRUE;
     }
   }
 }

/*******************************************************************\

Function: filecopy

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

bool filecopy(int file, std::ostream &out)
 {
  unsigned long int buffersize;
  long int bytesread;
  char *buffer;

  buffersize=64000l;
  if((buffer=(char *)malloc(buffersize))==NULL) return TRUE;

  while(TRUE)
   {
    bytesread=read(file, buffer, buffersize);
 
    if(bytesread==0)
     {
      free(buffer);
      return FALSE;
     }
    else if(bytesread<0)
     {
      free(buffer);
      return TRUE;
     }

    if(!out.write(buffer, bytesread))
     {
      free(buffer);
      return TRUE;
     }
   }
 }

/*******************************************************************\

Function: filecopy

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

bool filecopy(std::istream &in, int out, unsigned long int size)
 {
  unsigned long int buffersize, bytestocopy, bytestocopy2;
  char *buffer;

  buffersize=64000l;
  if((buffer=(char *)malloc(buffersize))==NULL) return TRUE;
  bytestocopy=size;

  while(bytestocopy!=0)
   {
    bytestocopy2=bytestocopy>buffersize?buffersize:bytestocopy;

    if(!in.read(buffer, bytestocopy2))
     {
      free(buffer);
      return TRUE;
     }

    if(write(out, buffer, bytestocopy2)!=(ssize_t)bytestocopy2)
     {
      free(buffer);
      return TRUE;
     }

    bytestocopy-=bytestocopy2;
   }
  free(buffer);
  return FALSE;
 }

