#include <iostream>
#include <string>
#include <list>

#include <dblib/index.h>
#include <libdbox/stringtools.h>
#include <libdbox/mtoolrfc.h>

class dbsmtpdt
 {
 public:
  dbsmtpdt(std::istream &_in, std::ostream &_out);
  
  void dbsmtpd();

 protected:
  std::istream &in;
  std::ostream &out;

  std::string command, arg;
  std::string hostname;
  std::string peer, helo;
  std::string maildir;

  bool quit, mail_from_set;
  std::string mail_from;

  struct rcptt
   {
    std::string rcpt;
    std::string user;
   };

  std::list<rcptt> rcpt;

  indext mail_index;

  void help();

  std::string strip_brackets(const std::string &s);
  std::string strip_space(const std::string &s);

  std::string preprocess(const std::string &s)
   {
    return dn_string(strip_brackets(strip_space(s)));
   }

  void check_rcpt(const std::string &address);
  void check_mail(const std::string &address);
  void vrfy(const std::string &address);
  void get_data();
  void deliver(std::list<std::string> &lines);
  bool is_spam(std::list<std::string> &lines);
  bool check_spam();
  void deliver_puffer_erfc(const rfcmessaget &message);
  void deliver_puffer_erfc(const rfcmessaget &message, const std::string &user);

  void get_user(const std::string &address,
                std::string &user,
                std::string &error);

  void get_user_localhost(const std::string &address,
                          std::string &user,
                          std::string &error);

  void process_request();
  void status_response(unsigned code, const std::string &msg);

  void parse_command();

  void read_command();
  void read_header();

  void add_received_header(std::list<std::string> &lines);
  void add_message_id_header(std::list<std::string> &lines);
 };

