/*

  DBOX Module
  Copyright (C) 2003 Daniel Kroening <kroening@handshake.de>

  Purpose: base class for remote mailbox access

*/

#include <dbclient/lock.h>
#include <dbclient/logstr.h>
#include <dbclient/client.h>

#include "folder_path.h"
#include "mailfolder.h"

/*******************************************************************\

Function: mailfoldert::mailfoldert

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

mailfoldert::mailfoldert(const std::string &_user,
                         const std::string &_folder_name):
  user(_user),
  folder_name(_folder_name)
 {
 }

/*******************************************************************\

Function: mailfoldert::get_path

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

std::string mailfoldert::get_path() const
 {
  std::string path;

  folder_path(client.config["maildir"], user, folder_name, path);

  return path;
 }
