/*

  DBOX Module
  Copyright (C) 1994-2003 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#ifndef DBOX_MAILFOLDER_H
#define DBOX_MAILFOLDER_H

#include <string>

#include <dbclient/lock.h>

class mailfoldert:public lockt
 {
 public:
  std::string get_path() const;

  void set_folder_name(const std::string &_folder_name)
   {
    folder_name=_folder_name;
   }

  void set_user(const std::string &_user)
   {
    user=_user;
   }

  const std::string &get_folder_name()
   {
    return folder_name;
   }

  const std::string &get_user()
   {
    return user;
   }

  void lock(const std::string &module)
   {
    lockt::lock("folder", folder_name+"@"+user, module);
   }
  
  mailfoldert(const std::string &_user,
              const std::string &_folder_name);

  mailfoldert()
   {
   }

 protected:
  std::string user, folder_name;
 };

#endif
