/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dbclient/client.h>

#include "spool_in_folder.h"
#include "folder_insert.h"
#include "folder_path.h"
#include "mailfolder.h"

/*******************************************************************\

Function: match_header

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void spool_in_folder(rfcmessaget &m,
                     const std::string &folder_owner,
                     const std::string &mailbox_name,
                     bool forceextern,
                     const std::string &envelope_to,
                     const std::string &envelope_from)
 {
  // get name

  std::string maildir=client.config["maildir"];
  std::string name;

  if(folder_owner.empty())
    throw excpt("no folder owner");

  folder_name(maildir, folder_owner, mailbox_name, name);

  if(name.empty())
    throw excpt("failed to get folder "+mailbox_name);

  mailfoldert mailfolder(folder_owner, name);

  // lock
  mailfolder.lock("spool_in_folder");

  // insert message into folder

  dword nr;
  folder_insert(m, mailfolder.get_path(),
                forceextern,
                envelope_to, envelope_from, nr);

  // the destructor will take care of the lock
 }
