/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#if 0
#include <signal.h>
#include <fcntl.h>
#include <unistd.h>

#include <iostream>
#include <fstream>

#include <dblib/table.h>

#include <libdbox/stringtools.h>
#include <libdbox/dboxversion.h> 
#include <libdbox/dboxpath.h>
#include <libdbox/userdb.h>
#include <libdbox/logfile.h>
#include <libdbox/lock.h>
#endif
#include <libdbox/logfile.h>
#include <libdbox/flags.h>

#include "dbsrv.h"

/*******************************************************************\

Function: dbsrvt::auth

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void dbsrvt::auth(const std::string &user, const std::string &password)
 {
  if(auth_ok)
   {
    std::cout << "-ERR already authenticated\r\n";
    return;
   }

  up.setname(user);
  dnstring(up.name);

  if(up.name=="" || up.read())
   {
    std::cout << "-ERR invalid password, bye\r\n";
    return;
   }

  userlogfile=std::string(up.getpath())+"logfile";

  std::string alias=up|"alias";

  if(alias!="")
   {
    up.setname(alias);

    if(up.read())
     {
      std::cout << "-ERR invalid password, bye\r\n";
      return;
     }
   }

  if(verifylogin(&up, password.c_str()))
   {
    std::cout << "-ERR invalid password, bye\r\n";
    logfileprintf(userlogfile.c_str(), "dbsrv", "wrong password");
    return;
   }

   {
    grouppt gp(up|"gruppe");

    gp.read();

    if(!getinternalflag(&up, &gp, LOGIN_NETZ))
     {
      std::cout << "-ERR access denied, bye\r\n";
      logfileprintf(userlogfile.c_str(), "dbsrv", "access denied");
      return;
     }
   }

  std::cout << "+OK Welcome, " << up.name << "\r\n";

  auth_ok=TRUE;    

  logfileprintf(userlogfile.c_str(), "dbsrv", "service %s login",
                service.c_str());
 }

