#ifndef DBOX_DBSRV_H

#define DBOX_DBSRV_H

/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dblib/stream_table.h>

#include <libdbox/userdb.h>

class dbsrvt
 {
 public:
  dbsrvt(std::istream &_in, std::ostream &_out):
    in(_in), out(_out) { }
 
  void dodbsrv();

 protected:
  bool auth_ok;
  internetaddresst peer;
  std::string userlogfile;
  userpt up;

  std::string service;
  std::string name;
  void parse();
  std::vector<std::string> id;
  void send_table(const stream_tablet &table);

  void get();
  void getpeer();
  void auth(const std::string &user, const std::string &password);
  
  std::istream &in;
  std::ostream &out;
 };
 
void dodbsrv(std::istream &in, std::ostream &out); 

#endif
