/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <fstream>

#include <dblib/table.h>

#include "dbsrv.h"

/*******************************************************************\

Function: dbsrvt::send_table

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void dbsrvt::send_table(const stream_tablet &table)
 {
  switch(table.type())
   {
   case table_baset::NOT_SET:
    assert(FALSE);
    break;

   case table_baset::LIST:
    out << "LIST" << std::endl;
    table.write(out);
    out << std::endl;
    break;

   case table_baset::SET:
    out << "SET" << std::endl;
    table.write(out);
    out << std::endl;
    break;

   case table_baset::MAP:
    out << "MAP" << std::endl;
    table.write(out);
    out << std::endl;
    break;

   case table_baset::VALUE:
    out << "VALUE" << std::endl;
    table.write(out);
    break;
   }
 }

/*******************************************************************\

Function: dbsrvt::get

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void dbsrvt::get()
 {
  stream_tablet table(name);

  if(id.size()==4 && 
     id[1]=="user" &&
     id[3]=="alias")
   {
    table.set_type(table_baset::SET);

    std::string filename=up.getpath();
    filename+="alias";

    std::ifstream infile(filename.c_str());

    if(!infile)
     {
      char tempstr[TEXTLEN*2], *tptr, ch;

      while(infile.get(tempstr, TEXTLEN-1))
       {
        infile.get(ch); // read \n
        tptr=strchr(tempstr, '\r'); if(tptr!=NULL) *tptr=0;
        tptr=strchr(tempstr, '\n'); if(tptr!=NULL) *tptr=0;
        if(tempstr[0]!=0) table.get_set().insert(tempstr);
       }
     }

    send_table(table);
   }
  else if(id.size()==4 &&
          id[1]=="user" &&
          id[3]=="profile")
   {
    table.set_type(table_baset::MAP);

    for(unsigned i=0; i<up.size(); i++)
      table.get_map().insert(std::pair<std::string, std::string>
        (up.data[i].id, up.data[i].data));

    send_table(table);
   }
  else if(id.size()==5 &&
          id[1]=="user" &&
          id[3]=="profile")
   {
    table.set_type(table_baset::VALUE);
    table.get_value()=up.get(id[4].c_str());
    send_table(table);
   }
  else
    std::cout << "-ERR unknown table\r\n";
 }

