/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <dboxpath.h>
#include <log_serv.h>
#include <dboxversion.h>
#include <config.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include "dbsrv.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
  parseoptionst():parseoptions_baset("p:") { }
 };

int parseoptionst::doit()
 {
  log_serv.openlog("dbsrv");

  if(config.read(""))
    return TRUE;

  dodbsrv(std::cin, std::cout);

  return 0;
 }

void parseoptionst::help()
 {
  std::cout <<
    "\n"
    "* * DBSRV - DBOX Database Server - Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " dbsrv [-?] [-h]              show help\n"
    " dbsrv                        run server\n"
    "\n"
    "Additonal options:\n"
    "\n";
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
