#ifndef DBOX_FOLDER_ACCESS_H
#define DBOX_FOLDER_ACCESS_H

#include <mtoolrfc.h>
#include <folderindex.h>
#include <mimeparse.h>

class folder_accesst
 {
 public:
  int header, index;
  folderindext fi;

  rfcmessaget rfcm;
  mimestructt *mimestruct;
  
  virtual bool get_folderindex(dword nr);
  virtual bool get_header(dword nr);
  virtual bool get_body(dword nr);
  virtual bool get_structure(dword nr);

  virtual bool open(const std::string &path);
  virtual bool close();
  
  virtual bool re_open()
   {
    if(close()) return true;
    return _open();
   }

  virtual dword get_number_of_messages();
  
  virtual bool search_uid(dword uid, dword &nr);
  
  folder_accesst();
  virtual ~folder_accesst();

  virtual void clear_cached();
  
  virtual const std::string &path()
   {
    return _path;
   }
    
 protected:
  bool opened;
  std::string _path;
  dword cached_nr;
  bool cached_header, cached_folderindex, cached_body, cached_structure;
  
  virtual void check_cache(dword nr);
  virtual bool _open();
 };

#endif
