#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <signal.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <dirent.h>

#include <dbox.h>
#include <dblib/cmdline.h>
#include <config.h>
#include <dboxpath.h>
#include <dboxversion.h>
#include <libdboxversion.h>
#include <log_serv.h>
#include "netd.h"
#include "netclient.h"

static bool parseoptions(int argc, char **argv)
 {
  char boxname[TEXTLEN]="";
  const char *arg;
  cmdlinet cmdline;

  if(cmdline.parse(argc, argv, "?hb:p:n:s:t:"))
    goto aufruf;

  if(cmdline.isset('?') || cmdline.isset('h'))
    goto help;

  arg=cmdline.getval('b');
  if(arg!=NULL) strmaxcpy(boxname, arg, TEXTLEN-1);

  if(config.read(boxname))
    return TRUE;
  
   { 
    char logfile[DIRLEN];
    sprintf(logfile, BOXLOGDIR "netd.log", config.boxdir);
    log_serv.setlogfile(logfile);
   }

  if(cmdline.args.size()==0)
   {
    if(cmdline.isset('s'))
      goto aufruf;

    donetd();
   }
  else
    donetclient(&cmdline);

  return FALSE;

 aufruf:
  printf("Falscher Aufruf!\n");

 help:
  printf(
    "\n"
    "* * NETD - DBOX Module - "
    "Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Aufruf:                      Aktion:\r\n"
    "\n"
    " netd [-?] [-h]               Hilfe ausgeben\r\n"
    " netd system                  netd-Anruf\r\n"
    " netd                         netd-Server\r\n"
    "\r\n"
    "Weitere Optionen:\r\n"
    " -b boxname\r\n"
    " -p Port     (fr netd Anruf)\r\n"
    " -n Hostname (fr netd Anruf)\r\n"
    " -s Kennung  (fr netd Anruf: transfersuperuser)\r\n"
    " -t Typ\r\n"
    "\r\n"
   );

  return TRUE;
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR))
    return 1;

  parseoptions(argc, argv);

  return 0;
 }
