/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <fstream>

#include <dbox.h>
#include "device.h"
#include "online.h"
#include "help.h"
#include "wmail.h"
#include "html.h"
#include "www.h"
#include "htmlview.h"

bool dohtmlview(const char *filename, char *_url)
 {
  htmlformatt html;
  htmlviewt hv;
  bool erg;
  std::string url=_url;
 
  std::ifstream in(filename);

  if(!in) return TRUE;

  html.set_width(online.sizex);
  html.format(in);

  if(status.dologout)
    erg=TRUE;
  else
    erg=hv.view(html, url);

  strmaxcpy(_url, url.c_str(), TEXTLEN-1);

  return erg;
 }
