/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

#include <dbox.h>
#include <log_serv.h>
#include <logfile.h>
#include <config.h>
#include <dboxpath.h>
#include "logmail.h"

void logmail(FILE *outfilefrom, FILE *outfileto, 
             const char *from, const char *to, 
             zcmessaget *m, const char *emp)
 {
  char text[1000], *tptr;

  if(outfilefrom==NULL) from=NULL;

  if(from!=NULL)
   {
    timefprintf(outfilefrom);
    fprintf(outfilefrom, "I ");
   }

  timefprintf(outfileto);
  fprintf(outfileto, "O ");

  if(from==NULL)
    fprintf(outfileto, "-intern-\t");
  else
   {
    fprintf(outfileto, "%s\t", from);
    fprintf(outfilefrom, "%s\t", to);
   }

  if(m->wab==NULL)
    m->copyheadertext(text, m->abs, 999);
  else
    m->copyheadertext(text, m->wab, 999);

  tptr=strchr(text, ' ');
  if(tptr!=NULL) *tptr=0;

  fprintf(outfileto, "%s\t", text);
  if(from!=NULL) fprintf(outfilefrom, "%s\t", text);

  fprintf(outfileto, "%s\t", emp);
  if(from!=NULL) fprintf(outfilefrom, "%s\t", emp);

  m->copyheadertext(text, m->mid, 999);
  fprintf(outfileto, "%s\t", text);
  if(from!=NULL) fprintf(outfilefrom, "%s\t", text);

  fprintf(outfileto, "%lu\n", m->len+m->headerlen);
  if(from!=NULL) fprintf(outfilefrom, "%lu\n", m->len+m->headerlen);
 }

void logmail(const char *source, const char *dest, 
             zcmessaget *m, const char *emp)
 {
  FILE *outfilefrom, *outfileto;
  char tempstr[DIRLEN];

  snprintf(tempstr, DIRLEN, BOXUSERDIR "mail.log",
    config.boxdir, dest);

  outfileto=fopen(tempstr, "at");
  if(outfileto==NULL)
   {
    log_serv.printf("logmail", "Failed to open \"%s\"", tempstr);
    return;
   }

  snprintf(tempstr, DIRLEN, BOXUSERDIR "mail.log",
    config.boxdir, source);

  outfilefrom=fopen(tempstr, "at");
  if(outfilefrom==NULL)
   {
    log_serv.printf("logmail", "Failed to open \"%s\"", tempstr);
    fclose(outfileto);
    return;
   }

  logmail(outfilefrom, outfileto, source, dest, m, emp);

  fclose(outfileto);
  fclose(outfilefrom);
 }
