/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: main module of ZCONNECT mail spooler

*/

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

#include <dboxpath.h>
#include <mtoolzc.h>
#include <userdb.h>
#include <log_serv.h>
#include <dboxversion.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include "spool.h"
#include "spoolzcm.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
  parseoptionst():parseoptions_baset("l:") { }
 };

void parseoptionst::help()
 {
  std::cout << 
    "\n"
    "* * SPOOLZCM - DBOX Module ZConnect Mail - Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    " spoolzcm                     spool mail\n"
    "\n"
    "Additional options:\n"
    "  -b   system name\n"
    "  -l   maximum load\n"
    "\n";
 }

int parseoptionst::doit()
 {
  const char *maxloadarg;

  maxloadarg=cmdline.getval('l');
  if(maxloadarg!=NULL) maxload=atoi(maxloadarg);

  log_serv.openlog("spoolzcm");

  if(cmdline.args.size()==0)
    dospoolzcm();
  else
    help();

  return 0;
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR) || config.read(""))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }
