/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: reply to a mail

*/

#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>

#include <dboxpath.h>
#include <tools.h>
#include <folder.h>
#include <charsettools.h>
#include <stringtools.h>
#include <htmltools.h>
#include <nls.h>
#include <mtoolrfc.h>
#include <dblib/rfc1522.h>
#include <messageid.h>
#include <zconnect.h>
#include <log_serv.h>
#include "../online/gen_from.h"

#include "ostatus.h"
#include "webtools.h"
#include "webgetrfc.h"
#include "webmail.h"
#include "challenge.h"
#include "formatmessage.h"

void webmailt::reply_mail()
 {
  if(verify_challenge(http.getparameter("challenge"), status.userprofile))
    return;
      
  dword nr;
  std::string msg_id;

  if(get_msg_nr(nr, msg_id))
    return;

  startpage(out, "Mail beantworten");

  out << "<H1>Mail Antwort DBOX Webschnittstelle</H1><p>\n\n";

  if(getrfc.get_structure(nr))
   {
    out << "<p>Error: failed to get message!</p>\n";
   }
  else 
   {     
    std::string subject, recipient, from, mailto, name;
    rfcmessaget &rfcm = getrfc.rfcm;

    rfcm.findsingleheader(subject, "subject");  
    rfcm.findsingleheader(from, "from");

    out <<
      "<FORM ACTION=\"/email\">\n"
      "<center>\n" 
      << nls["webonline.recipient"]
      << ":<input type=\"text\" name=\"rcpt\" size=\"40\" maxlength=\"120\" value=\""
      << from
      << "\"><br>\n"
      "Zusammenfassung: <input type=\"text\" name=\"zusfsg\" size=\"40\" maxlength=\"120\"><br>\n"
      "Antwort an: <input type=\"text\" name=\"antwort\" size=\"40\" maxlength=\"120\"><br>\n"
      "Empfangsbest&auml;tigung: <input type=checkbox name=\"eb\" value=\"1\"><br>\n"
      "Betreff: "
      "<input type=\"text\" name=\"subject\" size=\"40\" maxlength=\"80\" value=\"Re:" << subject << "\"><p>\n"
      "<TEXTAREA name=\"body\" cols=\"40\" rows=\"20\" wrap=\"virtual\">";

    out <<  
      "</TEXTAREA><p>\n"
      "<INPUT TYPE=submit value=\"absenden\">\n"
      "<INPUT TYPE=hidden name=\"mailbox\" value=\"INBOX\">"
      "<INPUT TYPE=hidden name=\"action\" value=\"send\">"
      "<INPUT TYPE=hidden name=\"challenge\" value=\"" << http.getparameter("challenge") << "\">\n"
      "</center>\n"
      "</form>\n"
      "<p>\n";
   }
  
  showcopyright(out);
  endpage(out);
 }

#if 0
void webmailt::reply2_mail()
 {
  FILE *outfile;

  char outfilename[TEXTLEN]="", filename[TEXTLEN], abs[TEXTLEN], org[TEXTLEN];

  if(verify_challenge(http.getparameter("challenge"), status.userprofile))
     return;
      
  startpage(out, "Mail abgeschickt");

  snprintf(outfilename, DIRLEN, DBOXTEMPDIR "webonline.%u.msg",
    config.dboxdir, getpid());

  outfile=fopen(outfilename, "wb");

  if(outfile==NULL)
   {
    log_serv.printf("dowritemail", "Failed to create \"%s\"", outfilename);
    out << "<h1>Fehler beim Absenden!</h1>\n";
    endpage(out);
    return;
   }

  gen_abs(status, status.username, abs, org, TRUE);

  fprintf(outfile, "ABS:\t%s\r\n", abs);

  if(http.getparameter("antwort")[0]!=0)
    fprintf(outfile, "ANTWORT-AN:\t%s\r\n",
            http.getparameter("antwort"));

  fprintf(outfile, "BET:\t%s\r\n", http.getparameter("subject"));

  fprintf(outfile, "CHARSET:\tISO-8859-1\r\n"); 

  fprintf(outfile, "EDA:\t%s\r\n", make_eda_localtime().c_str());

  fprintf(outfile, "EMP:\t%s\r\n", http.getparameter("rcpt"));

  fprintf(outfile, "LEN:\t%u\r\n", strlen(http.getparameter("body")));

  fprintf(outfile, "MAILER:\tDBOX Webonline-Mailer\r\n");

  if(http.getparameter("eb")) fprintf(outfile, "EB:\r\n");

  fprintf(outfile, "MID:\t%s\r\n", gen_message_id("mailer").c_str());

  if(org[0]!=0) fprintf(outfile, "ORG:\t%s\r\n", org);
 
  fprintf(outfile, "ROT:\r\n");

  if(http.getparameter("zusfsg")[0]!=0)
    fprintf(outfile, "ZUSAMMENFASSUNG:\t%s\r\n",
            http.getparameter("zusfsg"));

  fprintf(outfile, "\r\n");  

  fprintf(outfile, "%s", http.getparameter("body"));

  fclose(outfile);
  
  snprintf(filename, DIRLEN, BOXSPOOLINZCMAILDIR "%s.%lu-%lu-%u",
           config.boxdir, status.username,
           status.midcounter++, time(NULL), config.port);

  rename(outfilename, filename);
	
  out << "<H1>Mail verschickt!</H1><p>\n\n";
 }
#endif

